#!/usr/bin/python3.6										
												
import os											
import requests											
import json											
												
def menu():											
												
        os.system('clear')										
        print ("Gestion del firewall")								
        print ("\t1 - Ver estado del Firewall en los switches")					
        print ("\t2 - Habilitar Firewall en switch")							
        print ("\t3 - Deshabilitar Firewall en switch")						
        print ("\t4 - Obtener las reglas de un switch")						
        print ("\t5 - Introducir una nueva regla en un switch")					
        print ("\t6 - Borrar una regla de un switch")							
        print ("\t7 - Configurar IP del controlador")							
        print ("\t8 - Salir\n")									
												
controlador = "127.0.0.1"									
												
while True:											
        menu()											
        opc = input("Elige una opcion: ")								
												
        if opc=="1":										
                r = requests.get('http://%s:8080/firewall/module/status' % controlador)			
                print(json.dumps(r.json(),indent=1))							
                input("Pulsar enter para continuar")							
        if opc=="2":										
                sw = input("Introduce el id del switch: ")						
                url = "http://" + controlador + ":8080/firewall/module/status/enable" + sw		
                r = requests.put(url)									
                input("Pulsar enter para continuar")							
        if opc=="3":										
                sw = input("Introduce el id del switch: ")						
                url = "http://" + controlador + ":8080/firewall/module/status/disable" + sw		
                r = requests.put(url)									
                input("Pulsar enter para continuar")							
        if opc=="4":										
                sw = input("Introduce el id del switch: ")						
                r = requests.get('http://%s:8080/firewall/rules/%s' % (controlador,sw))			
                print(json.dumps(r.json(),indent=1))							
                input("Pulsar enter para continuar")							
        if opc=="5":										
                sw = input("Introduce el id del switch: ")						
                ip_src = input("Introduce la red origen: ")						
                ip_dst = input("Introduce la red destino: ")						
                proto = input("Introduce el protocolo: ")						
                action = input("Introduce la accion: ")							
                prio = input("Introduce la prioridad: ")							
                datos = {}										
                datos['nw_src'] = ip_src								
                datos['nw_dst'] = ip_dst								
                datos['actions'] = action								
                datos['nw_proto'] = proto								
                datos['priority'] = prio									
                url = "http://" + controlador + ":8080/firewall/rules/" + sw				
                r = requests.post(url, data=json.dumps(datos))					
                input("Pulsar enter para continuar")							
        if opc=="6":										
                sw = input("Introduce el id del switch: ")						
                pol = input("Introduce el ID de la regla: ")						
                url = "http://" + controlador + ":8080/firewall/rules/" + sw				
                datos = {}										
                datos['rule_id'] = pol									
                r = requests.delete(url, data=json.dumps(datos))					
                input("Pulsar enter para continuar")							
        if opc=="7":										
                controlador = input("Introduce la IP del controlador: ")					
        if opc=="8":										
                break											
        else:											
                print("Escoge una opcion valida.\n")	